#!/usr/bin/perl

# Ce programme a t crit grace  l'article de
# Jrme Quelin dans le n 49 de GNU/Linux Magazine

# Il sert d'intermdiaire entre l'utilisateur
# (qui lance par exemple hellrevealed, qui n'est que
#  doomloader.pl --dlhard -file /ou/est/HR.WAD -iwad /ou/est/doom2.wad )
# et doom, il n'est donc pas  utiliser sans option.

# Il faut donc crire un fichier par monde dans lequel on veut jouer.
# Ce fichier automatise le chargement de fichiers wad, deh ou bex.
# Exemple, je veux jouer  The Parallel Dimension :
# Je cre un fichier bash  theparalleldimension  contenant :

# #!/bin/bash
# doomloader --dlhard -file /ou/est/PARALLEL.WAD -deh /ou/est/PARALLEL.DEH -iwad /ou/est/doom.wad --dltext "Jouer dans le deuxime pisode."
# 

use strict;

use File::Basename;

our $DLHELPFILE="helpfile.txt";
our $DLUSAGEFILE="usage.txt";
our $DLLICENSEFILE="gpl.txt";
our $DLVERSION="0.1";
our $DLDATE="30 mars 2003";
our $DLNAME=basename $0;
our $DLPORTLIST=('prboom','lxdoom','llxdoom');

our $opt_dlhelp = 0;
our $opt_dlversion = 0;
our $opt_dllicense = 0;
our $opt_dlport = 'prboom';
our $opt_dltext = " ";
our $opt_dlhard = 0;
our $opt_dlfunny = 0;
our $opt_dltotal = 0;


use Getopt::Long;
Getopt::Long::Configure( "no_ignorecase" );
# la casse est importante

Getopt::Long::Configure( "no_autoabbrev" );
# pas d'abbrviation, il faut que ceci reste compatible
# avec les options des ports de Doom

Getopt::Long::Configure( "pass_through" );
# pour laisser passer les options des ports de Doom comme -iwad

if ( @ARGV == "" )
{
	die "Je ne peux pas trouver $DLUSAGEFILE\n" unless -f $DLUSAGEFILE;
	print `cat $DLUSAGEFILE`;
	exit;
}		

GetOptions( "dlhelp" => \$opt_dlhelp,		# aide
	"dlversion" => \$opt_dlversion,		# version
	"dllicense" => \$opt_dllicense,		# license
	"dlport=s" => \$opt_dlport,		# doom port
	"dltext=s" => \$opt_dltext,		# texte additionnel
	"dlhard!" => \$opt_dlhard,		# balaise ?
	"dlfunny!" => \$opt_dlfunny,		# amusant ?
	"dltotal!" => \$opt_dltotal );		# conversion ?

if ( $opt_dlhelp == 1 )
{
	die "Je ne peux pas trouver $DLHELPFILE\n" unless -f $DLHELPFILE;
	die "Je ne peux pas trouver $DLUSAGEFILE\n" unless -f $DLUSAGEFILE;
	print `cat $DLUSAGEFILE`;
	print `cat $DLHELPFILE`;
	exit;
}

if ( $opt_dlversion == 1 )
{
	print "$DLNAME, version $DLVERSION, $DLDATE\n";
	exit;
}

if ( $opt_dllicense == 1 )
{
	die "Je ne peux pas trouver $DLLICENSEFILE\n" unless -f $DLLICENSEFILE;
	system("less $DLLICENSEFILE");
	exit;
}

our $test=0;
foreach our $testport ($DLPORTLIST)
{
	if ( $testport == $opt_dlport )
	{
		$test=1;
	}
}
if ( $test == 0 )
{
        print "$opt_dlport n'est pas un port connu par $DLNAME,\n";
        print "modifiez la variable DLPORTLIST\n";
        exit;
}

if ( $opt_dlhard == 1 )
{
	print "Mise en garde : ce monde est trs difficile !\n";
}

if ( $opt_dlfunny == 1 )
{
        print "Attention, ce monde n'est pas srieux !\n";
}

if ( $opt_dltotal == 1 )
{
        print "Soyez prvenus, ce monde est une conversion de Doom !\n";
}

print "$opt_dltext\n";

# J'aimerai faire une pause, comme  read  de bash.

if ( ( $opt_dltotal + $opt_dlfunny + $opt_dlhard > 0 ) || ( $opt_dltext ne " " ) )
{
	sleep 2;
}

# J'aimerais grer le type d'affichage (console ou X) avec $DISPLAY

exec("$opt_dlport @ARGV"); # on lance le port avec les options non utilises

